model = ['NCEPDOE2','ERA5','ACCESS-CM2','ACCESS-CM2-Chem','CESM2','CESM2-WACCM','CESM2-FV2','CESM2-WACCM-FV2','GFDL-CM4','GFDL-ESM4','HadGEM3-GC31-LL','UKESM1-0-LL','HadGEM3-GC31-LL','UKESM1-StratTrop','CNRM-CM6-1','CNRM-ESM2-1','MPI-ESM1-2-LR','SOCOL','MRI-ESM2-0']

nmodel = n_elements(model)
expe = strarr(nmodel) + 'historical'
expe[where(model eq 'ACCESS-CM2' or model eq 'MPI-ESM1-2-LR')] = 'amip'
take = where(model eq 'HadGEM3-GC31-LL')
expe[take[1]] = 'amip'

!p.multi=[0,2,11,0,0]
close,10
openw,10,'result_composite.txt'
for h=0,1 do begin
for m=0,nmodel-1 do begin
  if model[m] eq 'NCEPDOE2' then begin
    ens = ['1']
  endif
  if model[m] eq 'GFDL-CM4' or model[m] eq 'GFDL-ESM4' then begin
    if model[m] eq 'GFDL-CM4' then $
      ens = ['1'] $
    else ens = ['1','2','3']
    f = '1'
    if model[m] eq 'GFDL-CM4' then grid='gr2z' else grid = 'gr1z'
    period= '18500101-20141231'
  endif
  if model[m] eq 'CESM2' then begin
    ens = ['1','2','3','4','5','6','7','8','9','11']
    f = '1'
    grid='gn'
    period= '18500101-20150101'
  endif
  if model[m] eq 'CESM2-WACCM' then begin
    ens = ['1','2','3']
    f = '1'
    grid='gn'
    period= '18500101-20150101'
  endif
  if model[m] eq 'CESM2-WACCM-FV2' then begin
    ens = ['1','2','3']
    f = '1'
    grid='gn'
    period= '19791212-20150101'
  endif  
  if model[m] eq 'CESM2-FV2' then begin
    ens = ['1','2','3']
    f = '1'
    grid='gn'
    period= '19800101-20150101'
  endif  
  if model[m] eq 'UKESM1-0-LL' then begin
    ens = ['1','2','3','4','8','9','10','11','12','15','16','17','18','19']
    f = '2'
    grid='gnz'
    period= '19700101-20141230'
  endif
  if model[m] eq 'UKESM1-StratTrop' then begin
    ens = ['1','2','3']
    f = '2'
    grid='grz'
    period= '19600101-20181230'
  endif
  if model[m] eq 'HadGEM3-GC31-LL' then begin
    if model[m+1] eq 'UKESM1-0-LL' then begin
      ens = ['1','2','3','4','5']
      f = '3'
      grid='gnz'
      period= '19700101-20141230'
    endif else begin
      ens = ['1','2','3','4','5']
      f= '3'
      grid='gnz'
      period='19790101-20141230'
    endelse
  endif
  if model[m] eq 'CNRM-ESM2-1' then begin
    ens = ['1','2','3']
    f = '2'
    grid = 'grz'
    period= '18500101-20141231'
  endif
  if model[m] eq 'CNRM-CM6-1' then begin
    ens = strcompress([1,2,3,4,5,6,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,30],/remove_all)
;    ens = ['1','2','3']    
    f = '2'
    grid = 'grz'
    period= '18500101-20141231'
  endif
  if model[m] eq 'MPI-ESM1-2-LR' then begin
;    ens = strcompress(indgen(30)+1,/remove_all)
    ens = ['1','2','3']    
    f = '1'
    grid = 'gn'
    period= '19790101-20141231'
;    ens = ['1']
  endif
  if model[m] eq 'MRI-ESM2-0' then begin
    ens = strcompress(indgen(9)+1,/remove_all)
;    ens = ['1','2','3']    
    f = '1'
    grid = 'gnz'
    period= '18500101-20141231'
  endif
  if model[m] eq 'SOCOL' or model[m] eq 'ACCESS-CM2-Chem' then begin
    ens = strcompress([1,2,3],/remove_all)
;    ens = ['1','2','3']    
    f = '1'
    if model[m] eq 'SOCOL' then $
      grid = 'gnz' else grid = 'gn'
    period= '19600101-20181231'
 endif
  if model[m] eq 'MERRA2' then begin
    ens = strcompress([1],/remove_all)
;    ens = ['1','2','3']    
    f = '1'
    grid = 'gnz'
    period= '19800101-20181231'
 endif 
 if model[m] eq 'ACCESS-CM2' then begin
   ens=['1','2','3']
   f='2'
   grid='gn'
   period='19790101-20141231'
endif
;ens = [ens[0]]
 
  nens = n_elements(ens)
  for i=0,nens-1 do begin
    if model[m] ne 'UKESM1-StratTrop' and model[m] ne 'SOCOL' and model[m] ne 'MERRA2' and model[m] ne 'NCEPDOE2' and model[m] ne 'ACCESS-CM2-Chem' and model[m] ne 'ERA5' then begin
      path = '/data/ukca/CMIP6/archive/'
      filename = path + 'ta/ta_EdayZ_'+model[m]+'_'+expe[m]+'_r'+ens[i]+'i1p1f'+f+'_'+grid+'_'+period+'.nc'
      print,filename
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'plev')
      ncdf_varget,ncid,varid,p
      varid = ncdf_varid(ncid,'lat')
      ncdf_varget,ncid,varid,lat
      varid = ncdf_varid(ncid,'time')
      ncdf_varget,ncid,varid,time
      nt = n_elements(time)
      if strmid(model[m],0,5) eq 'CESM2' then time = time - 1849.*365.
      varid = ncdf_varid(ncid,'ta')
      ncdf_varget,ncid,varid,ta
      filename = path + 'zg/zg_EdayZ_'+model[m]+'_'+expe[m]+'_r'+ens[i]+'i1p1f'+f+'_'+grid+'_'+period+'.nc'
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'zg')
      ncdf_varget,ncid,varid,zg
      nlat = n_elements(lat)
      np = n_elements(p)
; check that time is consecutive
      j=long(1)
      repeat begin 
        if time[j] le time[j-1] then begin
          print,time[j],time[j-1]
          time = [time[0:j-1],time[j+1:nt-1]]
          ta1 = fltarr(nlat,np,nt-1)
          ta1[*,*,0:j-1] = ta[*,*,0:j-1]
          ta1[*,*,j:nt-2] = ta[*,*,j+1:nt-1]
          ta = ta1
          zg1 = fltarr(nlat,np,nt-1)
          zg1[*,*,0:j-1] = zg[*,*,0:j-1]
          zg1[*,*,j:nt-2] = zg[*,*,j+1:nt-1]
          zg = zg1
          nt=nt-long(1)
       endif else j=j+long(1) 
     endrep until j ge nt-2
    endif else if model[m] eq 'SOCOL' or model[m] eq 'ACCESS-CM2-Chem' or model[m] eq 'UKESM1-StratTrop' then begin
      path = '/data/ukca/CCMI2/archive/'
      filename = path + 'ta/ta_AdayZ_'+model[m]+'_refD1_r'+ens[i]+'i1p1f'+f+'_'+grid+'_'+period+'.nc'
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'plev')
      ncdf_varget,ncid,varid,p
      varid = ncdf_varid(ncid,'lat')
      ncdf_varget,ncid,varid,lat
      varid = ncdf_varid(ncid,'time')
      ncdf_varget,ncid,varid,time
      varid = ncdf_varid(ncid,'ta')
      ncdf_varget,ncid,varid,ta

      filename = path + 'zg/zg_AdayZ_'+model[m]+'_refD1_r'+ens[i]+'i1p1f'+f+'_'+grid+'_'+period+'.nc'
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'zg')
      ncdf_varget,ncid,varid,zg
      nt = n_elements(time)
      if model[m] ne 'UKESM1-StratTrop' then $
        time = findgen(nt) + julday(1,1,1960) - julday(1,1,1850) $
      else begin
        nt = 19800
        time = findgen(nt) + 110.*360.
        zg = zg[*,*,0:nt-1]
        ta = ta[*,*,0:nt-1]
      endelse
; UKESM1 uses 360-day calendar 
   endif else if model[m] eq 'NCEPDOE2' then begin
      path = '/data/ukca/NCEP-20CR/daily/'
      filename = path + 'zmair.1979-2022.nc'
      print,filename
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'pressure')
      ncdf_varget,ncid,varid,p
      p = p*100.
      varid = ncdf_varid(ncid,'latitude')
      ncdf_varget,ncid,varid,lat
      varid = ncdf_varid(ncid,'time')
      ncdf_varget,ncid,varid,time
      varid = ncdf_varid(ncid,'temperature')
      ncdf_varget,ncid,varid,ta

      filename = path + 'zmhgt.1979-2022.nc'
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'hgt')
      ncdf_varget,ncid,varid,zg
      nt = n_elements(time)
      time = findgen(nt) + julday(1,1,1979) - julday(1,1,1850)
   endif else begin
     path = '/data/ukca/ERA5/'
      filename = path + 'zmt_era5_polar_1979-2014.nc'
      print,filename
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'pressure')
      ncdf_varget,ncid,varid,p
      p = p*100.
      varid = ncdf_varid(ncid,'latitude')
      ncdf_varget,ncid,varid,lat
      varid = ncdf_varid(ncid,'time')
      ncdf_varget,ncid,varid,time
      varid = ncdf_varid(ncid,'temperature')
      ncdf_varget,ncid,varid,ta

      filename = path + 'zmz_era5_polar_1979-2014.nc'
      ncid = ncdf_open(filename)
      varid = ncdf_varid(ncid,'GPH')
      ncdf_varget,ncid,varid,zg
      nt = n_elements(time)
      time = findgen(nt) + julday(1,1,1979) - julday(1,1,1850)
      zg = reform(zg)
      ta = reform(ta)
    endelse
; reject missing data
    reject = where(abs(ta) gt 1e10, count)
    if count gt 0 then ta[reject] = !values.f_nan 
    reject = where(abs(zg) gt 1e10, count)
    if count gt 0 then zg[reject] = !values.f_nan
    
; work out years
    nt = n_elements(time)
    
    if nt mod 360 eq 0 then begin
; UKESM1 and HadGEM3 use 360-day calendar
      year = fix(time / 360.) + 1850
      doy = fix(time mod 360.)
    endif else if nt mod 365 eq 0 or strmid(model[m],0,5) eq 'CESM2' then begin
; GFDL-CM4 and GFDL-ESM4 use 365-day calendar
      year = fix(time / 365.) + 1850.
      doy = fix(time mod 365.) 
    endif else begin  
      julian = time + julday(1,1,1850,0,0,0)
      caldat,julian,month,day,year
; remove one day in a leap year, to make 365-day records
      print,nt
      if h eq 1 then $
        take = where(year mod 4 ne 0 or (year mod 100 eq 0 and year mod 1000 ne 0) or month ne 7 or day ne 1, nt) $
      else $
        take = where(month ne 2 or day ne 29, nt)
; remove 29 February (i.e. a southern summer day) to make a 365-day calendar.
;      take = where(month ne 2 or day ne 29,nt)
      print,nt
      year = year[take]
      time = time[take]
      doy = lindgen(nt) mod 365
      ta = ta[*,*,take]
      zg = zg[*,*,take]
    endelse
; remove years before 1980
    take = where(year ge 1980 and year le 2014,nt)
    ta = ta[*,*,take]
    zg = zg[*,*,take]
    time = time[take]
    year = year[take]
    doy = doy[take]

; take meridional mean over polar cap
    if lat[1] lt lat[0] then begin
      lat = reverse(lat)
      ta = reverse(ta,1)
      zg = reverse(zg,1)
    endif
    nlat = n_elements(lat)
    np = n_elements(p)
    lat1 = fltarr(nlat+1)
    lat1[1:nlat-1] = 0.5*(lat[0:nlat-2] + lat[1:nlat-1])
    lat1[0] = -90.
    lat1[nlat] = 90.
    if h eq 1 then begin
      for k=0,nlat do $
        if lat1[k] lt 75. then lat1[k] = 75. 
    endif else begin
      for k=0,nlat do $
        if lat1[k] gt -75. then lat1[k] = -75.
    endelse
 
    area = sin(lat1[1:nlat]*!dtor) - sin(lat1[0:nlat-1]*!dtor)    

    mmta_one = fltarr(np,nt)
    mmzg_one = fltarr(np,nt)
    for j=0,np-1 do $
      for k=0,nt-1 do begin
        onevec = reform(ta[*,j,k])
        take = where(onevec gt 0., count)
        mmta_one[j,k] = total(ta[take,j,k]*area[take])/total(area[take])
        onevec = reform(zg[*,j,k])
        take = where(onevec gt 0., count)
        mmzg_one[j,k] = total(zg[take,j,k]*area[take])/total(area[take])
      endfor
    mmta_one = smooth(mmta_one,[1,15],/edge_truncate)
    mmzg_one = smooth(mmzg_one,[1,15],/edge_truncate)

; make year start on 1 May or 1 September
    if nt mod 360 eq 0 then begin
      if h eq 0 then begin
        mmta_one = mmta_one[*,120:nt-241]
        mmzg_one = mmzg_one[*,120:nt-241]
        year = year[120:nt-241]
        doy = doy[120:nt-241]
      endif else begin
        mmta_one = mmta_one[*,240:nt-121]
        mmzg_one = mmzg_one[*,240:nt-121]
        year = year[240:nt-121]
        doy = doy[240:nt-121]
      endelse
      nt = nt - 360
      nyear = nt/360
      yearlen = 360
    endif else begin
      if h eq 0 then begin
        mmta_one = mmta_one[*,120:nt-246]
        mmzg_one = mmzg_one[*,120:nt-246]
        year = year[120:nt-246]
        doy = doy[120:nt-246]
      endif else begin
        mmta_one = mmta_one[*,243:nt-123]
        mmzg_one = mmzg_one[*,243:nt-123]
        year = year[243:nt-123]
        doy = doy[243:nt-123]
      endelse
      nt = nt - 365
      nyear = nt/365
      yearlen = 365
    endelse
    mmta_one = reform(mmta_one,np,yearlen,nyear)
    mmzg_one = reform(mmzg_one,np,yearlen,nyear)
    if i eq 0 then begin
      mmta = fltarr(np,yearlen,nyear,nens)
      mmzg = fltarr(np,yearlen,nyear,nens)
    endif
    mmta[*,*,*,i] = mmta_one
    mmzg[*,*,*,i] = mmzg_one
  endfor
  mmta = reform(mmta,np,yearlen,nyear*nens)
  mmzg = reform(mmzg,np,yearlen,nyear*nens)
  nyear = nyear*nens

; calculate mean annual cycle
  mean_cyc_ta = fltarr(np,yearlen)
  mean_cyc_zg = fltarr(np,yearlen)
  for k=0,np-1 do $
    for j=0,yearlen-1 do begin
      mean_cyc_ta[k,j] = mean(mmta[k,j,*])
      mean_cyc_zg[k,j] = mean(mmzg[k,j,*])
    endfor

; remove mean annual cycle
  for k=0,nyear-1 do begin
    mmta[*,*,k] = mmta[*,*,k] - mean_cyc_ta
    mmzg[*,*,k] = mmzg[*,*,k] - mean_cyc_zg
  endfor

; produce density map of temperature anomalies
  plevel = where(p eq 7000.)
  density = fltarr(yearlen,81)
  threshold = findgen(81)-40.
  for k=0,nyear-1 do $
    for l=0,yearlen-1 do $
      density[l,mmta[plevel,l,k]+40] = density[l,mmta[plevel,l,k]+40] + 1./float(nyear)

  hem = ['Antarctic','Arctic']
  close,11
  openw,11,model[m]+'_'+expe[m]+'_'+hem[h]+'_tdensity.txt'
  printf,11,yearlen
  printf,11,'Density of temperature deviations'
  printf,11,density
  close,11
   
    contour,transpose(mean_cyc_ta),findgen(yearlen),p/100.,/ylog,yrange=[1000.,1.],nlevels=10,/cell_fill
    for i=0,nyear-1 do $
      if i eq 0 then $
        plot,findgen(yearlen),mmta[plevel,*,i],yrange=[-20,20]$
      else $
        oplot,findgen(yearlen),mmta[plevel,*,i]
    
; find seven warmest and coldest seasons at 70 hPa
    maxtemp = fltarr(nyear)
    mintemp = fltarr(nyear)
    doymin = fltarr(nyear)
    yearlist = indgen(nyear)
    for i=0,nyear - 1 do begin
      maxtemp[i] = max(mmta[plevel,*,i])
      mintemp[i] = min(mmta[plevel,*,i],mindoy)
      doymin[i] = mindoy
      print,mindoy
    endfor
    maxsort = sort(maxtemp)
    minsort = sort(mintemp)
    ncold = round(nyear*0.2)
    print,doymin[minsort[0:ncold-1]]
;    for i=0,ncold-1 do $
;      if i eq 0 then $
;        plot,findgen(yearlen),mmta[plevel,*,maxsort[nyear-1-i]],yrange=[-20,20] $
;      else oplot,findgen(yearlen),mmta[plevel,*,maxsort[nyear-1-i]]
    plot,findgen(yearlen),fltarr(yearlen),yrange=[-25,25] 
    for i=0,ncold-1 do $
      oplot,findgen(yearlen),mmta[plevel,*,minsort[i]],linestyle=2
    for i=0,ncold-1 do $
      oplot,[doymin[minsort[i]],doymin[minsort[i]]],[-20,20]

    composite_ta = fltarr(np,231)
    composite_zg = fltarr(np,231)
    t_test_ta = fltarr(np,231)
    t_test_zg = fltarr(np,231)
    ncold1 = 0
    for i=0,ncold-1 do begin
      if doymin[minsort[i]]-130 ge 0 and doymin[minsort[i]] + 100 le yearlen-1 then begin
        composite_ta = composite_ta + reform(mmta[*,doymin[minsort[i]]-130:doymin[minsort[i]]+100,minsort[i]])
        composite_zg = composite_zg + reform(mmzg[*,doymin[minsort[i]]-130:doymin[minsort[i]]+100,minsort[i]])
        ncold1 = ncold1 + 1
      endif
    endfor
    for j=0,np-1 do begin
      print,j
      for k=-130,100 do begin
        mmta_one = fltarr(nyear)
        for l=0,nyear-1 do $
          if doymin[l]+k lt 0 then $
            mmta_one[l] = mmta[j,doymin[l]+k+yearlen,l-1] $
          else if doymin[l]+k ge yearlen then begin
            if l lt nyear-1 then begin
              mmta_one[l] = mmta[j,doymin[l]+k-yearlen,l+1]
            endif
          endif else mmta_one[l] = mmta[j,doymin[l]+k,l]
        mmta_cold = fltarr(ncold)
        for l=0,ncold-1 do $
          if doymin[minsort[l]]+k lt 0 then $   
            mmta_cold[l] = mmta[j,doymin[minsort[l]]+k+yearlen,minsort[l]-1] $
          else if doymin[minsort[l]]+k ge yearlen then $
            mmta_cold[l] = mmta[j,doymin[minsort[l]]+k-yearlen,minsort[l]+1] $
          else mmta_cold[l] = mmta[j,doymin[minsort[l]]+k,minsort[l]]
          result = tm_test(mmta_cold,mmta_one)
          t_test_ta[j,k] = result[1]
;          stop
           mmzg_one = fltarr(nyear)
        for l=0,nyear-1 do $
          if doymin[l]+k lt 0 then $
            mmzg_one[l] = mmzg[j,doymin[l]+k+yearlen,l-1] $
          else if doymin[l]+k ge yearlen then begin
            if l lt nyear-1 then mmzg_one[l] = mmzg[j,doymin[l]+k-yearlen,l+1] 
          endif else mmzg_one[l] = mmzg[j,doymin[l]+k,l]
          mmzg_cold = fltarr(ncold)
        for l=0,ncold-1 do $
          if doymin[minsort[l]]+k lt 0 then $
            mmzg_cold[l] = mmzg[j,doymin[minsort[l]]+k+yearlen,minsort[l]-1] $
          else if doymin[minsort[l]]+k ge yearlen then $
            mmzg_cold[l] = mmzg[j,doymin[minsort[l]]+k-yearlen,minsort[l]+1] $
          else mmzg_cold[l] = mmzg[j,doymin[minsort[l]]+k,minsort[l]]
        result = tm_test(mmzg_cold,mmzg_one)
        t_test_zg[j,k] = result[1]
      endfor
    endfor

    composite_ta = composite_ta / ncold1
    composite_zg = composite_zg / ncold1
    contour,transpose(composite_ta),findgen(231)-130.,p/100.,/ylog,levels=findgen(13)*2.-14.,yrange=[1000,1],/cell_fill
    contour,transpose(composite_zg),findgen(231)-130.,p/100.,/ylog,levels=[-1000,-300,-100,-30,-10,-3,0,3,10,30,100,300],yrange=[1000,1],/cell_fill
   printf,10,model[m]
   printf,10,'ncold = '
   printf,10,ncold
   printf,10,'Days of year when minimum temperature occurred'
   printf,10,doymin[minsort[0:ncold-1]]
   printf,10,'Number of pressure levels'
   printf,10,np
   printf,10,'Pressure levels'
   printf,10,p
   printf,10,'Composite temperature'
   printf,10,composite_ta
   printf,10,'T-test ta'
   printf,10,t_test_ta
   printf,10,'Composite GPH'
   printf,10,composite_zg
   printf,10,'T-test zg'
   printf,10,t_test_zg
endfor
endfor
close,10
end
