for h=0,1 do begin
for co=0,1 do begin
  if co eq 0 then begin
    model = ['NCEPDOE2','ACCESS-CM2-Chem','CESM2-WACCM','CESM2-WACCM-FV2','GFDL-ESM4','UKESM1-0-LL','UKESM1-StratTrop','CNRM-ESM2-1','SOCOL','MRI-ESM2-0','ERA5']
    f = ['0','1','1','1','1','2','2','2','','1','1','1']
    grid = ['','gn','gn','gn','gr1','gn','gnz','gr','gn','gn','gr1']
    expe = strarr(n_elements(model)) + 'historical'
    expe[where(model eq 'ACCESS-CM2-Chem' or model eq 'UKESM1-StratTrop' or model eq 'SOCOL')] = 'REF-D1'
    color=[0,100,150,200,50,150,200,250,250,100,0]
    colorscale=[40,40,40,40,42,42,42,40,42,42,40]
    linestyle=2*[0,1,0,0,0,0,1,0,1,0,0]
  endif else begin
    model = ['NCEPDOE2','ACCESS-CM2','CESM2','CESM2-FV2','GFDL-CM4','HadGEM3-GC31-LL','HadGEM3-GC31-LL','CNRM-CM6-1','MPI-ESM1-2-LR','ERA5']
    f = ['0','2','1','1','1','3','3','2','1','1','1']
    grid = ['','gn','gn','gn','gr1','gn','gn','gr','gn','gr1']
    expe = strarr(n_elements(model)) + 'historical'
    expe[where(model eq 'ACCESS-CM2' or model eq 'MPI-ESM1-2-LR')] = 'amip'
    expe[6] = 'amip'
    color=[0,100,150,200,50,150,200,250,250,0]
    colorscale=[40,40,40,40,42,42,42,40,42,40]
    linestyle=2*[0,1,0,0,0,0,1,0,1,0]
  endelse
fieldname = ['ta']
nmodels = n_elements(model)
for m=0,nmodels-1 do begin
; read UKESM temperatures & 100 hPa
if model[m] eq 'NCEPDOE2' or model[m] eq 'ERA5' then ens = ['1']
if model[m] eq 'UKESM1-0-LL' then ens = ['1','2','3','4','8','9','10','11','12','16','17','18','19'] 
if model[m] eq 'CESM2-WACCM' or model[m] eq 'CESM2-WACCM-FV2' then ens = ['1','2','3']
if model[m] eq 'GFDL-CM4' then ens = ['1']
if model[m] eq 'GFDL-ESM4' then ens = ['1','2','3'] 
if model[m] eq 'CNRM-ESM2-1' then ens = ['1','2','3','4','5','7','8','9','10']
if model[m] eq 'UKESM1-StratTrop' or model[m] eq 'CESM2-FV2' or model[m] eq 'SOCOL' or model[m] eq 'ACCESS-CM2-Chem' then ens = ['1','2','3']
if model[m] eq 'MRI-ESM2-0' then ens = ['1','2','3','4','5']
if model[m] eq 'HadGEM3-GC31-LL' then ens = ['2','3','4']
if m eq 6 and model[m] eq 'HadGEM3-GC31-LL' then ens = ['1','2','3','4','5']
if model[m] eq 'CESM2' then ens = ['1','2','3','4','5','6','7','8','9','10','11']
if model[m] eq 'CNRM-CM6-1' then ens = strcompress([indgen(19)+1,[21,22],indgen(7)+24],/remove_all)
if model[m] eq 'MPI-ESM1-2-LR' then ens = ['1','2','3']
if model[m] eq 'ACCESS-CM2' then ens = ['1','2','3']
if expe[m] eq 'historical' then period='185001-201412' else $
  if expe[m] eq 'REF-D1' then period='196001-201812' else $
    if expe[m] eq 'amip' then period='197901-201412'

;ens = [ens[0]]
nens = n_elements(ens)

for i=0,nens-1 do begin
    path = '/data/ukca/CMIP6/archive/'+fieldname[0]+'/'
    if fieldname[0] eq 'o3' then path = path + expe[m]+'/'
    filename = path+fieldname[0]+'_Amon_'+model[m]+'_'+expe[m]+'_r'+ens[i]+'i1p1f'+f[m]+'_'+grid[m]+'_'+period+'.nc'
    if model[m] eq 'CESM2-WACCM-FV2' then filename = path+fieldname[0]+'_Amon_'+model[m]+'_historical_r'+ens[i]+'i1p1f'+f[m]+'_'+grid[m]+'_190001-201412.nc'
    if model[m] eq 'NCEPDOE2' then filename = '/data/ukca/NCEPDOE2/air.mon.mean.zm.nc'
    if model[m] eq 'ERA5' then filename = '/data/ukca/ERA5/ta_AmonZ_ERA5_historical_r1i1p1f1_gr1_197901-202203.nc'    
    if model[m] eq 'SOCOL' then filename = '/data/ukca/CCMI2/archive/ta/ta_Amon_SOCOL_refD1_gn_r'+ens[i]+'i1p1f1_'+period+'.nc'
    IF model[m] eq 'ACCESS-CM2-Chem' then filename = '/data/ukca/CCMI2/archive/ta/ta_AmonZ_ACCESS-CM2-Chem_refD1_r'+ens[i]+'i1p1f1_gn_'+period+'.nc'
    IF model[m] eq 'UKESM1-StratTrop' then filename = '/data/ukca/CCMI2/archive/ta/ta_AmonZ_UKESM1-StratTrop_refD1_r'+ens[i]+'i1p1f2_grz_19600101-20190101.nc'
    openu,10,filename,error=err
    if err ne 0 then $
      filename = path+fieldname[0]+'_Amon_'+model[m]+'_historical_r'+ens[i]+'i1p1f'+f[m]+'_'+grid[m]+'_195001-201412.nc'
    close,10
    print,filename
    ncid = ncdf_open(filename)
    varid = ncdf_varid(ncid,'time')
    ncdf_varget,ncid,varid,time
    nt = n_elements(time)
    if model[m] eq 'NCEPDOE2' then begin
       varid = ncdf_varid(ncid,'lat')
        ncdf_varget,ncid,varid,lat
        varid = ncdf_varid(ncid,'level')
        ncdf_varget,ncid,varid,p
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[12],count=[420]
        varid = ncdf_varid(ncid,'air')
        ncdf_varget,ncid,varid,field,offset=[0,0,12],count=[73,17,420]
         p = p*100.
        if lat[1] lt lat[0] then begin
          lat = reverse(lat)
          field = reverse(field,1)
        endif
        lon = [0]
        field = reform(field,1,73,17,420)
        time = time / 24.
        caldat,time + julday(1,1,1800),month,day,year
     endif else if model[m] eq 'ERA5' then begin
        varid = ncdf_varid(ncid,'ta')
        ncdf_varget,ncid,varid,field,offset=[0,0,12],count=[721,37,420]
        varid = ncdf_varid(ncid,'lat')
        ncdf_varget,ncid,varid,lat
        lon = [0]
        varid = ncdf_varid(ncid,'plev')
        ncdf_varget,ncid,varid,p
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[12],count=[420]
        p = p*100.
        field =reform(field,1,721,37,420)
      endif else begin  
      varid = ncdf_varid(ncid,fieldname[0])
      if nt eq 708 then begin
; start in 1960.
        if model[m] eq 'SOCOL' then $
          ncdf_varget,ncid,varid,field,offset=[0,0,0,240],count=[192,96,47,420]$
        else if model[m] eq 'UKESM1-StratTrop' then begin
          ncdf_varget,ncid,varid,field,offset=[0,0,240],count=[145,39,420]
          field = reform(field,1,145,39,420)
        endif else begin
          ncdf_varget,ncid,varid,field,offset=[0,0,240],count=[144,39,420]
          field = reform(field,1,144,39,420)
        endelse
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[240],count=[420]
      endif else if nt eq 1380 then begin
; start in 1900
        ncdf_varget,ncid,varid,field,offset=[0,0,0,960]
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[960]
      endif else if nt gt 1200 then begin
; start in 1850
        ncdf_varget,ncid,varid,field,offset=[0,0,0,1560]
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[1560]
      endif else if nt eq 432 then begin
; start in 1979
        ncdf_varget,ncid,varid,field,offset=[0,0,0,12]
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[12]
      endif else begin
; start in 1950 
        ncdf_varget,ncid,varid,field,offset=[0,0,0,360]
        varid = ncdf_varid(ncid,'time')
        ncdf_varget,ncid,varid,time,offset=[360]
      endelse
      reject = where(field gt 1e10)
      field[reject] = !values.f_nan
      varid = ncdf_varid(ncid,'lat')
      ncdf_varget,ncid,varid,lat
      if model[m] ne 'ACCESS-CM2-Chem' and model[m] ne 'UKESM1-StratTrop' then begin
        varid = ncdf_varid(ncid,'lon')
        ncdf_varget,ncid,varid,lon
      endif else lon = [0.]
      if model[m] eq 'SOCOL' then begin
        varid = ncdf_varid(ncid,'a')
        ncdf_varget,ncid,varid,a
        varid = ncdf_varid(ncid,'b')
        ncdf_varget,ncid,varid,b
        varid = ncdf_varid(ncid,'p0')
        ncdf_varget,ncid,varid,p0
        varid = ncdf_varid(ncid,'ps')
        ncdf_varget,ncid,varid,ps,offset=[0,0,240],count=[192,96,420]
        pres = fltarr(192,96,47,420)
        for i1=0,46 do $
          pres[*,*,i1,*] = a[i1]*p0 + b[i1]*ps
        field1 = fltarr(192,96,19,420)
        for i1=0,191 do $
          for j1=0,95 do $
            for k=0,419 do begin
              index = interpol(findgen(47),reform(pres[i1,j1,*,k]),p)
              onevec = interpolate(reform(field[i1,j1,*,k]),index,/grid)
              field1[i1,j1,*,k] = onevec
            endfor
        field = field1
      endif else begin
        varid = ncdf_varid(ncid,'plev')
        ncdf_varget,ncid,varid,p
      endelse
      ncdf_close,ncid
    endelse
    nlon = n_elements(lon)
    nlat = n_elements(lat)
    np = n_elements(p)
    nt = n_elements(time)
    if i eq 0 then $
      fields = fltarr(nlat,np,nt,nens)
; compute zonal mean
    field2 = fltarr(nlat,np,nt)
    nent = intarr(nlat,np,nt)
    for j=0,nlon-1 do begin
      oneslice = reform(field[j,*,*,*])
      take = where(oneslice ge 0.)
      field2[take] = field2[take] + oneslice[take]
      nent[take] = nent[take] + 1
    endfor
    take = where(nent gt nlon/2, complement=reject)
    field2[take] = field2[take] / nent[take]
 ;   if size(reject) gt 0 then field2[reject] = !values.f_nan
    fields[*,*,*,i] = reform(field2)
  endfor

; produce polar-cap means
nhlfields = fltarr(np,nt,nens)
lat1 = fltarr(nlat+1)
lat1[1:nlat-1] = 0.5*(lat[0:nlat-2] + lat[1:nlat-1])
lat1[0] = -90.
lat1[nlat] = 90.
lat2 = lat1
if h eq 0 then begin
  reject = where(lat1 gt -75.)
  lat1[reject] = -75.
endif else begin
  reject = where(lat1 lt 75.)
  lat1[reject] = 75.
endelse
area = sin(lat1[1:nlat]*!dtor) - sin(lat1[0:nlat-1]*!dtor)
for i=0,nt-1 do $
  for j=0,nens-1 do $
    for k=0,np-1 do begin
        onerow = reform(fields[*,k,i,j])
        take = where(onerow ge 0.)
        nhlfields[k,i,j] = total(onerow[take]*area[take]) / total(area[take])
      endfor

; find 70 hPa level
take = where(p eq 7000.)
take = take[0]

; reduce to March/April mean
nyears = nt/12
nhlfields = reform(nhlfields,np,12,nyears,nens)
nhlfields = reform(nhlfields[take,*,*,*])

if m eq 0 then stddev=fltarr(12,nmodels)
for i=0,11 do $
  stddev[i,m] = stdev(nhlfields[i,*,*])
if m eq 0 then meant = fltarr(12,nmodels)
for i=0,11 do $
  meant[i,m] = mean(nhlfields[i,*,*])

endfor
if co eq 0 and h eq 0 then begin
  set_plot,'ps'
  device,filename='temp_stdev.ps',/color,/times,xsize=16,ysize=25
  !p.font=0
  !p.multi=[0,2,4,0,0]
endif
title=['Antarctic','Arctic']
s = [6,0]
if h eq 0 then begin
  yrange=[-21,10]
  incr = 1.6 
endif else begin
  yrange=[-12,10]
  incr = 1.1
endelse
psym=intarr(nmodels)
psym[nmodels-1] = 2
color[nmodels-1] =0
loadct,colorscale[0]
plot,findgen(12),fltarr(12),thick=0.0001,xtitle='month',ytitle = 'T bias [K]',yrange=yrange,xrange=[0,11],xmargin=[3,3],xstyle=1,ystyle=1,ycharsize=ycharsize,title=title[h]+' cap mean T bias',xticks=11,xtickname=shift(['J','F','M','A','M','J','J','A','S','O','N','D'],s[h]),color=color[0],linestyle=1
for m=1,nmodels-1 do begin
ycharsize=1.
if m eq 0 then begin
  loadct,colorscale[m]
  plot,findgen(12),shift(meant[*,m]-meant[*,0],6),thick=3,xtitle='month',ytitle = 'T bias [K]',yrange=[-6,10],xrange=[0,11],xmargin=[3,3],xstyle=1,ystyle=1,ycharsize=ycharsize,title=title[h]+' cap mean T bias',xticks=11,xtickname=shift(['J','F','M','A','M','J','J','A','S','O','N','D'],s[h]),color=color[m],linestyle=linestyle[m]
  xyouts,0.5,8.9-1.*(m-1),model[m],color=color[m],charsize=0.8
endif else begin
  loadct,colorscale[m]
  oplot,findgen(12),shift(meant[*,m]-meant[*,0],s[h]),thick=3,color=color[m],linestyle=linestyle[m],psym=psym[m],symsize=0.6
  xyouts,0.5+5.5*((m-1)/5),8.4-incr*((m-1) mod 5),model[m],color=color[m],charsize=0.8 
endelse
endfor

for m=0,nmodels-1 do begin
ycharsize=1.
if m eq 0 then begin
  loadct,colorscale[m]
  plot,findgen(12),shift(stddev[*,m],s[h]),thick=3,xtitle='month',ytitle = 'std(T) [K]',yrange=[0,15],xrange=[0,11],xstyle=1,ystyle=1,ycharsize=ycharsize,title=title[h]+' cap T standard deviation',xmargin=[3,3],xticks=11,xtickname=shift(['J','F','M','A','M','J','J','A','S','O','N','D'],s[h]),color=color[m],linestyle=linestyle[m]
  xyouts,0.5,14.-0.7*m,model[m],color=color[m],charsize=0.8
endif else begin
  loadct,colorscale[m]
  oplot,findgen(12),shift(stddev[*,m],s[h]),thick=3,color=color[m],psym=psym[m],symsize=0.6,linestyle=linestyle[m]
  xyouts,0.5+5.5*(m/6),14.-0.85*(m mod 6),model[m],color=color[m],charsize=0.8
endelse
endfor
endfor
endfor
device,/close
spawn,'gv temp_stdev.ps &'

end
