close,11
openw,11,'polar_cap_ozone.txt'

for hem=0,1 do begin
models = ['MSR-2','CMIP6','ACCESS-CM2-Chem','CESM2-WACCM','CESM2-WACCM-FV2','CNRM-ESM2-1','GFDL-ESM4','MRI-ESM2-0','UKESM1-0-LL','UKESM1-StratTrop','SOCOL','CNRM-CM6-1']
start = [1979, 1850, 1960, 1850, 1850, 1850, 1850, 1850, 1850,1960,1960,1850]
latname=strarr(12) + 'latitude'
latname[5:7] = 'lat'
latname[8:9] = 'lat'
latname[11] = 'lat'
path = '/data/ukca/CMIP6/archive/toz/historical/'
printf,11,'hem = ',hem
for m=0,n_elements(models)-1 do begin
  printf,11,models[m]
  grid = 'gn'
  if models[m] eq 'CNRM-ESM2-1' or models[m] eq 'CNRM-CM6-1' then grid = 'gr'
  if models[m] eq 'GFDL-ESM4' then grid = 'gr1'
  filename = path + 'toz_AERmon_'+models[m]+'_historical_zm_'+grid+'_185001-201412.nc'
  print,filename
  if models[m] eq 'MSR-2' then filename = '/data/ukca/MSR/MSR-2.nc'
  ncid = ncdf_open(filename)
  varname = 'toz'
  if m eq 0 then varname = 'Average_O3_column'
  varid = ncdf_varid(ncid,varname)
  ncdf_varget,ncid,varid,toz
  reject = where(toz le 0. or toz ge 1.e10, count)
  if count gt 0 then toz[reject] = !values.f_nan
  print,max(toz,/nan)
  if max(toz,/nan) lt 1 then toz = toz * 100000.
  if max(toz,/nan) gt 1e7 then toz = toz * 1e-5
  dims = size(toz)
  if dims[0] eq 3 then begin
; form zonal mean (for MSR-2)
    nlon = dims[1]
    nlat = dims[2]
    nt = dims[3]
    toz1 = fltarr(nlat,nt)
    nent = intarr(nlat,nt)
    for i=0,nlon-1 do begin
      toz2 = reform(toz[i,*,*])
      take = where(toz2 gt 0, count)
      if count gt 0 then begin
        toz1[take] = toz1[take] + toz2[take]
        nent[take] = nent[take] + 1
      endif
    endfor
    take = where(nent gt nlon/2, complement=reject)
    toz1[take] = toz1[take] / nent[take]
    toz1[reject] = !values.f_nan
    toz = toz1
  endif else begin
    nlat = dims[1]
    nt = dims[2]
  endelse
  varid = ncdf_varid(ncid,latname[m])
  ncdf_varget,ncid,varid,lat  
  if lat[0] gt lat[1] then begin
   lat = reverse(lat)
   toz = reverse(toz,1)
  endif
; form meridional mean
  lat1 = fltarr(nlat+1)
  lat1[1:nlat-1] = 0.5*(lat[0:nlat-2] + lat[1:nlat-1])
  lat1[0] = -90.
  lat1[nlat] = 90.
  if hem eq 0 then begin
    reject = where(lat1 gt -75.)
    lat1[reject] = -75.
  endif else begin
    reject = where(lat1 lt 75.)
    lat1[reject] = 75.
  endelse
  area = sin(lat1[1:nlat]*!dtor) - sin(lat1[0:nlat-1]*!dtor)
  toz1 = fltarr(nt)
  for i=0,nt-1 do begin
    toz2 = reform(toz[*,i])
    take = where(toz2 gt 0., count)
    if count gt 0 then $
      toz1[i] = total(toz2[take]*area[take])/total(area[take]) $
    else toz1[i] = !values.f_nan
  endfor

  nyears = nt/12
  toz1 = reform(toz1,12,nyears)
  years = findgen(nyears) + start[m]
  if m eq 0 and hem eq 0 then begin
    set_plot,'ps'
    device,/color,filename='CMIP6_TCO.ps',/time,xsize=16,ysize=25
    !p.font=0
    loadct,70
  endif
  if m eq 0 then !p.multi=[0,2,6,0,0]
  toz1 = reform(toz1,12,nyears)
  if hem eq 0 then $
    levels = findgen(15)*20+100 $
  else levels = findgen(17)*15+250
  nlevels=n_elements(levels)
  if hem eq 0 then begin
    poslevels = n_elements(where(levels ge 220.))
    neglevels = n_elements(where(levels lt 220.))
    c_colors = [(findgen(neglevels)*128)/neglevels,128+(findgen(poslevels)*127)/(poslevels-1)]
    print,c_colors
  endif else c_colors = findgen(nlevels)/(nlevels-1)*254.
  if m ge 10 then xcharsize=1. else xcharsize=0.0001
  if m mod 2 eq 0 then ycharsize=1 else ycharsize=0.00001
  contour,smooth(transpose(toz1),[11,1],/edge_truncate,/nan),findgen(nyears)+start[m], findgen(12),yticks=11,ytickname=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],levels=levels,/cell_fill,title=models[m],xtitle='year',ytitle='month',xrange=[1979,2014],xstyle=1,yrange=[0,11],ystyle=1,c_colors=c_colors,xcharsize=xcharsize,ycharsize=ycharsize,ymargin=[1.2,1.2],xmargin=[0,0],charsize=1.3
  contour,smooth(transpose(toz1),[11,1],/edge_truncate,/nan),findgen(nyears)+start[m], findgen(12),levels=[220],/overplot,thick=4

;  if m eq 0 then plot,years,smooth(reform(toz1[month,*]),11,/edge_truncate),color=28*m,xrange=[1979,2014],xstyle=1,yrange=[320,530],ystyle=1,thick=3,xtitle='year',ytitle='March TCO [DU]' $
;  else oplot,years,smooth(reform(toz1[month,*]),11,/edge_truncate),thick=3,color=28*m,linestyle=(m mod 3)
;  if m le 4 then xyouts,1980,520-10*m,models[m],color=28*m,charsize=0.9 $
;  else xyouts,1998,520-10*(m-5),models[m],color=28*m,charsize=0.9
  take = where(toz1^2 gt 0.,complement=reject)
  if n_elements(reject) gt 0 then begin
    toz1[reject] = -1. 
  endif
  time = findgen(nyears) + start[m]
  take = where(time ge 1979. and time lt 2015., nyears1)
  printf,11,toz1[*,take],format='(12(F6.1))'
endfor
colorbar,[0.01,-0.03,0.91,-0.02],levels,c_colors
endfor
close,11
device,/close
spawn,'gv CMIP6_TCO.ps &'
end
