; Display the composite T and GPH anomalies

filename = 'cold_period_stats.txt'
close,11
openw,11,filename
filename = 'result_composite.txt'
close,10
openr,10,filename
nmodels=19
hem = ['Antarctic','Arctic']
for h=0,1 do begin
for m=0,nmodels-1 do begin
  model_name = ''
  readf,10,model_name
  junk = ''
  readf,10,junk
  ncold = 0
  readf,10,ncold
  readf,10,junk
  daymin = fltarr(ncold)
  readf,10,daymin
  print,model_name
  print,mean(daymin),stddev(daymin)
  readf,10,junk
  np = 0
  readf,10,np
  readf,10,junk
  p = fltarr(np)
  readf,10,p
  readf,10,junk
  composite_ta = fltarr(np,231)
  readf,10,composite_ta
  readf,10,junk
  t_test = fltarr(np,231)
  readf,10,t_test
  reject = where(t_test gt 0.05)
  ;composite_ta[reject] = !values.f_nan
  readf,10,junk
  composite_zg = fltarr(np,231)
  readf,10,composite_zg
  readf,10,junk
  t_test = fltarr(np,231)
  readf,10,t_test
  reject = where(t_test gt 0.05)
  ;composite_zg[reject] = !values.f_nan

  if h eq 0 and m eq 0 then begin
    set_plot,'ps'
    device,filename='model_composite.ps',xsize=16,ysize=25,/color,/times
    loadct,70
    !p.multi=[0,2,nmodels,0,0]
    !p.font=0
  endif
  if m eq nmodels-1 then xcharsize=1. else xcharsize=0.00001
  levels = [-20,-15,-10,-7,-5,-3,-2,-1,0,1,2,3,4,5,6,8,10]
  nlevels = n_elements(levels)
  print,m,' ',model_name
  if model_name eq 'HadGEM3-GC31-LL' then begin
    if m eq 10 then model_name = model_name + ' (hist)'
    if m eq 12 then model_name = model_name + ' (AMIP)'
  endif
  c_colors = 256 - (fix(findgen(nlevels)/(nlevels-1)*253. + 1.))
  contour,transpose(composite_ta),findgen(231)-130.,p/100.,/ylog,yrange=[1000,1.0001],/cell_fill,levels=levels,c_colors=c_colors,ytitle='p [hPa]',xtitle='day after cold event',xstyle=1,xmargin=[0,0],xcharsize=xcharsize,ymargin=[0,0],ystyle=1
; track lowest temperature
  lowest_temp = fltarr(231)
  pres = fltarr(231)
  ind = intarr(231)
  for i=0,230 do begin
    take = where(p ge 100.)
    profile = reform(composite_ta[take,i])
    mi = min(profile,index)
    lowest_temp[i] = mi
    pres[i] = p[take[index]]/100.
    ind[i] = take[index]
  endfor
; find gaps in the lowest temperature
  cluster = intarr(231)
  clust=0
  nclust = intarr(231)
  for i=0,230 do begin
    if lowest_temp[i] lt -3. then begin
      if i eq 0 then begin
        clust = clust + 1
        cluster[i] = clust
        nclust[i] = 1
     endif else begin
        if cluster[i-1] eq 0 then clust = clust + 1
        cluster[i] = clust
        nclust[i] = nclust[i-1] + 1
      endelse   
    endif 
    print,i,max(cluster),lowest_temp[i]
  endfor
  longest_cluster = max(nclust,index)
  longest_cluster = cluster[index]
  take = where(cluster eq longest_cluster)
  
;  if model_name eq 'UKESM1-StratTrop' then stop
  days = findgen(231)-130.
;  take = where(lowest_temp lt -3)
  printf,11,model_name
  printf,11,min(days[take]),max(days[take]),n_elements(take)
  printf,11,days[take]
  printf,11,lowest_temp[take]
  oplot,days[take],smooth(pres[take],1,/edge_truncate),thick=4  
  if m eq 0 then title = model_name + ' ' + hem[h] else title = model_name
;  xyouts,-10,3,title,charsize=0.6,font=0,charthick=2
  !p.charsize=0.7
  if m eq nmodels-1 then $
    colorbar,[-0.03,-0.035,0.43,-0.025],levels,c_colors
  xyouts,0,70,'+',alignment=0.5,charthick=4
  !p.charsize=1.
  levels = [-1.7,-1,-.7,-.4,-.2,-.1,-.03,-.01,0,.01,.03,.1,.2]
  nposlevels = n_elements(where(levels ge 0.))
  nneglevels = n_elements(where(levels lt 0.))
  c_colors = 256 - ([findgen(nneglevels)/nneglevels*128.,128+findgen(nposlevels)/(nposlevels-1)*60.])
  contour,transpose(composite_zg)/1000.,findgen(231)-130.,p/100.,/ylog,yrange=[1000,1.0001],/cell_fill,levels=levels,c_colors=c_colors,xtitle='day after cold event',xstyle=1,ycharsize=0.00001,xmargin=[0,0],xcharsize=xcharsize,ymargin=[0,0],ystyle=1
  if m eq 0 then title = model_name + ' ' + hem[h] else title = model_name
  xyouts,10,3,title,charsize=0.6,font=0,charthick=2
  !p.charsize=0.7
  if m eq nmodels-1 then $
    colorbar,[0.47,-0.035,0.94,-0.025],levels,c_colors
  !p.charsize=1.
endfor
endfor
close,11
device,/close
spawn,'gv model_composite.ps &'
end

