model = ['ERA5','NCEPDOE2','UKESM1-0-LL','HadGEM3-GC31-LL','UKESM1-StratTrop','HadGEM3-GC31-LL','CNRM-ESM2-1','CNRM-CM6-1','SOCOL','MPI-ESM1-2-LR','CESM2-WACCM','CESM2','CESM2-WACCM-FV2','CESM2-FV2','GFDL-ESM4','GFDL-CM4','ACCESS-CM2-Chem','ACCESS-CM2','MRI-ESM2-0']
nmodels = n_elements(model)
expe = strarr(nmodels) + 'historical'
expe[where(model eq 'ACCESS-CM2' or model eq 'MPI-ESM1-2-LR')] = 'amip'
expe[5] = 'amip'
set_plot,'ps'
!p.font=0
device,filename='density_plots_T.ps',xsize=16,ysize=24,/times,/color
loadct,38
hem = ['Arctic','Antarctic']
for h=0,1 do begin
!p.multi=[0,2,10,0,0]
for m=0,nmodels-1 do begin
  filename = model[m] + '_'+expe[m]+'_'+hem[h]+'_tdensity.txt'
  close,10
  openr,10,filename
  readf,10,yearlen
  density = fltarr(yearlen,81)
  junk = ''
  readf,10,junk
  readf,10,density
  if h eq 0 then begin
    if yearlen eq 360 then start = -120 else start = -122
    xrange=[-120,239]
 endif else begin
    if yearlen eq 360 then start = -240 else start = -245
    xrange=[-240,119]
  endelse
  if m mod 2 eq 0 then ycharsize=1. else ycharsize=0.00001
  if m gt nmodels-3 then xcharsize=1. else xcharsize=0.00001 
  levels = [0.001,0.002,0.003,0.005,0.007,0.01,0.02,0.05,0.1,0.3,0.6]
  nlevels=n_elements(levels)
  colors = findgen(nlevels)/(nlevels-1)*254
  if h eq 0 then yrange=[-27,30] else yrange=[-27,40]
  title = model[m]
  if title eq 'HadGEM3-GC31-LL' then begin
    if m eq 3 then title = title+'(hist)'
    if m eq 5 then title = title+'(amip)'
  endif
  contour,density,findgen(yearlen)+start,findgen(81)-40.,levels=levels,/fill,ytitle='temperature anom [K]',xtitle='day after 1 January',yrange=yrange,ystyle=1,xrange=xrange,xstyle=1,xcharsize=xcharsize,ycharsize=ycharsize,xmargin=[0,0],ymargin=[0,0],c_colors=colors
  oplot,[-240,240],[0,0]
  xpos = start+200
  if h eq 1 then xpos=start+50
  xyouts,xpos,yrange[1]-(yrange[1]-yrange[0])*0.12,title,charsize=0.7
  oplot,[0,0],[-50,50],thick=3
endfor
colorbar,[-0.03,-0.035,0.94,-0.025],levels,colors
endfor
device,/close
spawn,'gv density_plots_T.ps &'
end
  
