filename = 'polar_cap_ozone.txt'
nmodels = 12
close,11
names=strarr(nmodels)
openr,11,filename
nyears = 2015-1979
toc = fltarr(12,nyears,2,nmodels) 
for hem=0,1 do begin
  junk = ''
  readf,11,junk
  for i=0,nmodels-1 do begin
    readf,11,junk
    names[i] = strcompress(junk,/remove_all)
    toc1 = fltarr(12,nyears)
    readf,11,toc1,format='(12(F6.1))'
    toc[*,*,hem,i] = toc1
  endfor
endfor

reject = where(toc eq -1.)
toc[reject] = !values.f_nan
set_plot,'ps'
device,filename='polar_ozone.ps',/color,/times,ysize=8,xsize=16
!p.multi=[0,2,1,0,0]
loadct,40
colors = [0,50,100,150,200,250,50,100,150,200,250,250]
linestyle=2*[0,0,1,0,0,0,0,0,0,1,1,2]
plot,findgen(nyears)+1979,smooth(reform(toc[9,*,0,0]),11,/edge_truncate),thick=5,xrange=[1979,2014],xstyle=1,yrange=[110,310],ystyle=1,title='Antarctic, October',xmargin=[2,2],ytitle='total column ozone [DU]',xtitle='year'
for i=1,nmodels-1 do begin
  if i le 5 or i eq 11 then loadct,40 else loadct,42
  oplot,findgen(nyears)+1979,smooth(reform(toc[9,*,0,i]),11,/edge_truncate),color=colors[i],thick=2,linestyle=linestyle[i]
endfor
for i=0,nmodels-1 do begin
  if i le 5 or i eq 11 then loadct,40 else loadct,42
  if i le 5 then xyouts,1985,300-10*i,names[i],color=colors[i],charsize=0.7 $
  else xyouts,2000,300-10*(i-6),names[i],color=colors[i],charsize=0.7
endfor
loadct,40
plot,findgen(nyears)+1979,smooth(reform(toc[2,*,1,0]),11,/edge_truncate),xrange=[1979,2014],xstyle=1,yrange=[320,480],ystyle=1,title='Arctic, March',xmargin=[2,2],thick=5,xtitle='year'
for i=1,nmodels-1 do begin
  if i le 5 or i eq 11 then loadct,40 else loadct,42
  oplot,findgen(nyears)+1979,smooth(reform(toc[2,*,1,i]),11,/edge_truncate),color=colors[i],thick=2,linestyle=linestyle[i]
endfor
device,/close
spawn,'gv polar_ozone.ps &'
set_plot,'x'
end
